diff -r ee55d0546576 src/company_gui.cpp
--- a/src/company_gui.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/company_gui.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -24,6 +24,10 @@
 #include "widgets/dropdown_type.h"
 #include "tilehighlight_func.h"
 #include "settings_type.h"
+#include "currency.h"
+#include "openttd.h"
+#include "company_gui.h"
+#include "window_func.h"
 
 #include "table/strings.h"
 
@@ -33,9 +37,51 @@
 
 static void DoShowCompanyFinances(CompanyID company, bool show_small, bool show_stickied, int top = FIRST_GUI_CALL, int left = FIRST_GUI_CALL);
 static void DoSelectCompanyManagerFace(Window *parent, bool show_big, int top =  FIRST_GUI_CALL, int left = FIRST_GUI_CALL);
+static void ShowSharingSettingsWindow(CompanyID company);
 
-/** Standard unsorted list of expenses. */
+/** Standard unsorted list of expenses with infrastructure sharing enabled. */
 static ExpensesType _expenses_list_1[] = {
+	EXPENSES_CONSTRUCTION,
+	EXPENSES_NEW_VEHICLES,
+	EXPENSES_TRAIN_RUN,
+	EXPENSES_ROADVEH_RUN,
+	EXPENSES_AIRCRAFT_RUN,
+	EXPENSES_SHIP_RUN,
+	EXPENSES_SHARED_RUN,
+	EXPENSES_PROPERTY,
+	EXPENSES_TRAIN_INC,
+	EXPENSES_ROADVEH_INC,
+	EXPENSES_AIRCRAFT_INC,
+	EXPENSES_SHIP_INC,
+	EXPENSES_SHARED_INC,
+	EXPENSES_LOAN_INT,
+	EXPENSES_OTHER,
+};
+
+/** Grouped list of expenses with infrastructure sharing enabled. */
+static ExpensesType _expenses_list_2[] = {
+	EXPENSES_TRAIN_INC,
+	EXPENSES_ROADVEH_INC,
+	EXPENSES_AIRCRAFT_INC,
+	EXPENSES_SHIP_INC,
+	EXPENSES_SHARED_INC,
+	INVALID_EXPENSES,
+	EXPENSES_TRAIN_RUN,
+	EXPENSES_ROADVEH_RUN,
+	EXPENSES_AIRCRAFT_RUN,
+	EXPENSES_SHIP_RUN,
+	EXPENSES_SHARED_RUN,
+	EXPENSES_PROPERTY,
+	EXPENSES_LOAN_INT,
+	INVALID_EXPENSES,
+	EXPENSES_CONSTRUCTION,
+	EXPENSES_NEW_VEHICLES,
+	EXPENSES_OTHER,
+	INVALID_EXPENSES,
+};
+
+/** Standard unsorted list of expenses with infrastructure sharing disabled. */
+static ExpensesType _expenses_list_3[] = {
 	EXPENSES_CONSTRUCTION,
 	EXPENSES_NEW_VEHICLES,
 	EXPENSES_TRAIN_RUN,
@@ -51,8 +97,8 @@
 	EXPENSES_OTHER,
 };
 
-/** Grouped list of expenses. */
-static ExpensesType _expenses_list_2[] = {
+/** Grouped list of expenses with infrastructure sharing disabled. */
+static ExpensesType _expenses_list_4[] = {
 	EXPENSES_TRAIN_INC,
 	EXPENSES_ROADVEH_INC,
 	EXPENSES_AIRCRAFT_INC,
@@ -81,6 +127,8 @@
 static const ExpensesList _expenses_list_types[] = {
 	{ _expenses_list_1, lengthof(_expenses_list_1), lengthof(_expenses_list_1) * 10 },
 	{ _expenses_list_2, lengthof(_expenses_list_2), lengthof(_expenses_list_2) * 10 + 3 * 12 },
+	{ _expenses_list_3, lengthof(_expenses_list_3), lengthof(_expenses_list_3) * 10 },
+	{ _expenses_list_4, lengthof(_expenses_list_4), lengthof(_expenses_list_4) * 10 + 3 * 12 },
 };
 
 /** Widgets of the company finances windows. */
@@ -104,7 +152,7 @@
 
 static void DrawCompanyEconomyStats(const Company *c, bool small, const Widget *widget)
 {
-	int type = _settings_client.gui.expenses_layout;
+	int type = _settings_game.sharing.enable_sharing ? _settings_client.gui.expenses_layout : _settings_client.gui.expenses_layout + 2;
 	int y;
 	const Money (*tbl)[EXPENSES_END];
 	StringID str;
@@ -333,7 +381,7 @@
 		const Company *c = GetCompany(company);
 
 		if (!small) {
-			int type = _settings_client.gui.expenses_layout;
+			int type = _settings_game.sharing.enable_sharing ? _settings_client.gui.expenses_layout : _settings_client.gui.expenses_layout + 2;
 			if (this->widget[CFW_EXPS_PANEL].bottom < this->widget[CFW_EXPS_PANEL].top) {
 				this->widget[CFW_EXPS_PANEL].bottom = this->widget[CFW_EXPS_PANEL].top;
 			}
@@ -1394,6 +1442,7 @@
 	CW_WIDGET_RELOCATE_HQ,
 	CW_WIDGET_BUY_SHARE,
 	CW_WIDGET_SELL_SHARE,
+	CW_WIDGET_COMPANY_SHARING,
 	CW_WIDGET_COMPANY_PASSWORD,
 	CW_WIDGET_COMPANY_JOIN,
 };
@@ -1410,6 +1459,7 @@
 {    WWT_TEXTBTN,   RESIZE_NONE,  COLOUR_GREY,   266,   355,    32,    43, STR_RELOCATE_HQ,                        STR_RELOCATE_COMPANY_HEADQUARTERS},
 { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_GREY,     0,   179,   158,   169, STR_COMPANY_VIEW_BUY_SHARE_BUTTON,      STR_COMPANY_VIEW_BUY_SHARE_TOOLTIP},
 { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_GREY,   180,   359,   158,   169, STR_COMPANY_VIEW_SELL_SHARE_BUTTON,     STR_COMPANY_VIEW_SELL_SHARE_TOOLTIP},
+{ WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_GREY,   266,   355,    46,    57, STR_COMPANY_SHARING,                    STR_COMPANY_SHARING_TOOLTIP},
 { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_GREY,   266,   355,   138,   149, STR_COMPANY_PASSWORD,                   STR_COMPANY_PASSWORD_TOOLTIP},
 { WWT_PUSHTXTBTN,   RESIZE_NONE,  COLOUR_GREY,   266,   355,   138,   149, STR_COMPANY_JOIN,                       STR_COMPANY_JOIN_TIP},
 {   WIDGETS_END},
@@ -1529,6 +1579,7 @@
 		this->SetWidgetHiddenState(CW_WIDGET_RELOCATE_HQ,      !local || c->location_of_HQ == INVALID_TILE);
 		this->SetWidgetHiddenState(CW_WIDGET_BUY_SHARE,        local);
 		this->SetWidgetHiddenState(CW_WIDGET_SELL_SHARE,       local);
+		this->SetWidgetHiddenState(CW_WIDGET_COMPANY_SHARING,  !(_settings_game.sharing.enable_sharing && _settings_game.sharing.individual_allowed));
 		this->SetWidgetHiddenState(CW_WIDGET_COMPANY_PASSWORD, !local || !_networking);
 		this->SetWidgetHiddenState(CW_WIDGET_COMPANY_JOIN,     local || !_networking);
 		this->SetWidgetDisabledState(CW_WIDGET_COMPANY_JOIN,   !IsHumanCompany(c->index));
@@ -1645,6 +1696,10 @@
 				DoCommandP(0, this->window_number, 0, CMD_SELL_SHARE_IN_COMPANY | CMD_MSG(STR_ERROR_CAN_T_SELL_25_SHARE_IN));
 				break;
 
+			case CW_WIDGET_COMPANY_SHARING:
+				ShowSharingSettingsWindow((CompanyID)this->window_number);
+				break;
+
 #ifdef ENABLE_NETWORK
 			case CW_WIDGET_COMPANY_PASSWORD:
 				if (this->window_number == _local_company) ShowNetworkCompanyPasswordWindow(this);
@@ -1783,3 +1838,453 @@
 {
 	AllocateWindowDescFront<BuyCompanyWindow>(&_buy_company_desc, company);
 }
+
+/** per-company sharing settings window */
+enum SharingSettingsWindowWidgets {
+	SSW_WIDGET_CLOSEBOX = 0,
+	SSW_WIDGET_CAPTION,
+	SSW_WIDGET_STICKY,
+	SSW_WIDGET_PANEL,
+	SSW_WIDGET_ICONS,
+	SSW_WIDGET_SETTINGS,
+	SSW_WIDGET_CURRENT,
+	SSW_WIDGET_BUTTONS,
+	SSW_WIDGET_FUTURE,
+	SSW_WIDGET_SCROLL,
+	SSW_WIDGET_OPTIONS,
+	SSW_WIDGET_COMPANIES,
+	SSW_WIDGET_RESIZE,
+};
+
+/** Min / max for the height of a text line. */
+enum {
+	MIN_LINE_HEIGHT    = 11,
+	MAX_LINE_HEIGHT    = 15,
+};
+
+/** String lookup table for station names ('Station', 'road stop' etc) */
+static const StringID _sharing_station_string[] = {
+	STR_SHARING_SETTING_STATION,
+	STR_SHARING_SETTING_ROADSTOP,
+	STR_SHARING_SETTING_DOCK,
+	STR_SHARING_SETTING_AIRPORT,
+};
+
+struct SharingSettingsWindow : public Window {
+private:
+	Company *company;                     ///< The company this window belongs to
+	CompanySharingSettingsEntry *future;  ///< future sharing settings
+	CompanySharingSettingsEntry *current; ///< current sharing settings
+
+	bool companies_tab;                   ///< Is the companies tab currently open?
+
+	VehicleType current_query_type;       ///< type of vehicle for which a querystring window is open.
+	byte clicked_row;                     ///< which of the arrow sets was clicked
+	byte clicked_side;                    ///< was the left or the right arrow clicked?
+
+	byte line_height;                     ///< The height of a line of text (FONT_HEIGHT_NORMAL, clamped between MIN/MAX_LINE_HEIGHT)
+
+public:
+	/** Constructor */
+	SharingSettingsWindow(const WindowDesc *desc, WindowNumber number) : Window(desc, number)
+	{
+		assert(IsValidCompanyID((CompanyID)number));
+		this->owner = (Owner)number;
+		this->company = GetCompany(number);
+		this->future = &company->sharing_future;
+		this->current = &company->sharing_current;
+
+		int text_height = this->widget[SSW_WIDGET_PANEL].bottom - this->widget[SSW_WIDGET_PANEL].top - 1;
+		this->line_height = Clamp(FONT_HEIGHT_NORMAL + 1, MIN_LINE_HEIGHT, MAX_LINE_HEIGHT);
+		this->resize.step_height = this->line_height;
+		this->vscroll.cap = text_height / this->line_height;
+
+		/* Resize the window, so it fits an exact number of lines */
+		int delta_y = this->line_height - (text_height % this->line_height);
+		this->resize.height += delta_y;
+		ResizeWindow(this, 0, delta_y);
+
+		this->FindWindowPlacementAndResize(desc);
+
+		/* Make sure the size is exactly correct */
+		assert(this->widget[SSW_WIDGET_PANEL].top + this->vscroll.cap * this->line_height + 1 == this->widget[SSW_WIDGET_PANEL].bottom);
+	}
+
+	/** Draw the value of a boolean setting ([Not] Allowed) in the column 'current' or 'future'.
+	 * @param top The y-coordinate where the string should be drawn.
+	 * @param value The boolean value to draw (Allowed / Not allowed).
+	 * @param future If true, draw in the column 'future', if false, draw in the column 'current'. */
+	inline void DrawBoolValue(int top, bool value, bool future)
+	{
+		const Widget *widget = future ? &this->widget[SSW_WIDGET_FUTURE] : &this->widget[SSW_WIDGET_CURRENT];
+		DrawString(widget->left + 2, widget->right - 2, top, value ? STR_SHARING_VALUE_ALLOWED : STR_SHARING_VALUE_NOT_ALLOWED, TC_ORANGE);
+ 	}
+
+	/** Draw a boolean sharing setting.
+	 * @param str The string to draw. (any parameters can be set beforehand)
+	 * @param top The y-coordinate where the string should be drawn. Is increased by this->line_height after drawing.
+	 * @param value_current The boolean value to draw (Allowed / Not allowed) in the column 'current'.
+	 * @param value_future The boolean value to draw (Allowed / Not allowed) in the column 'future'.
+	 */
+	void DrawSharingOption(StringID str, int &top, bool value_current, bool value_future)
+	{
+		static const Colours _button_colour_table[2][2] = {{COLOUR_CREAM, COLOUR_RED}, {COLOUR_DARK_GREEN, COLOUR_GREEN}};
+		DrawFrameRect(this->widget[SSW_WIDGET_BUTTONS].left, top, this->widget[SSW_WIDGET_BUTTONS].right, top + 8,
+			_button_colour_table[!!value_future][_local_company == this->owner], value_future ? FR_LOWERED : FR_NONE);
+
+		DrawString(this->widget[SSW_WIDGET_SETTINGS].left, this->widget[SSW_WIDGET_SETTINGS].right, top, str, TC_BLACK);
+		DrawBoolValue(top, value_current, false);
+		DrawBoolValue(top, value_future, true);
+		top += this->line_height;
+	}
+
+	/** Should the text line given by the parameter be drawn on de screen? (depends on scrolling)
+	 * Parameter 'line' is passed by reference, and always incremented by one.
+	 * @param Line the line to draw or not to draw.
+	 * @return True if the line is to be drawn.
+	 */
+	inline bool ShouldDrawLine(int &line)
+	{
+		if (IsInsideMM(line, this->vscroll.pos, this->vscroll.pos + this->vscroll.cap)) {
+			line++;
+			return true;
+		}
+		line++;
+		return false;
+	}
+
+	virtual void OnPaint()
+	{
+		this->SetWidgetDisabledState(SSW_WIDGET_OPTIONS, !this->companies_tab);
+		this->SetWidgetDisabledState(SSW_WIDGET_COMPANIES, this->companies_tab);
+
+		/* Determine the number of items that will be shown in the list (i.e. this->vscroll.count) */
+		byte num_scroll = 1; //1 line for headers
+		if (this->companies_tab) {
+			Company *c;
+			FOR_ALL_COMPANIES(c) {
+				if (this->owner != c->index) num_scroll++;
+			}
+		} else {
+			num_scroll += 13; //4 lines for the train settings, 3 * 2 for the other vehtypes, and 3 blank lines
+		}
+		if (this->company->sharing_delay > 0) {
+			num_scroll += 2; //1 blank line and 1 line for the delay
+		}
+		SetVScrollCount(this, num_scroll);
+		this->DrawWidgets();
+
+		int top = this->widget[SSW_WIDGET_PANEL].top + 1;
+		int current_line = 0;
+
+		/* draw text headers */
+		if (ShouldDrawLine(current_line)) {
+			DrawString(this->widget[SSW_WIDGET_CURRENT].left, this->widget[SSW_WIDGET_CURRENT].right, top, STR_SHARING_CURRENT, TC_BLACK);
+			DrawString(this->widget[SSW_WIDGET_FUTURE].left,  this->widget[SSW_WIDGET_FUTURE].right,  top, STR_SHARING_FUTURE,  TC_BLACK);
+			top += this->line_height;
+		}
+
+		if (this->companies_tab) {
+			Company *c;
+			FOR_ALL_COMPANIES(c) {
+				if (c->index == this->owner) continue; //Skip our own company, as it would be silly to allow / disallow yourself.
+				if (ShouldDrawLine(current_line)) {
+					DrawCompanyIcon(c->index, this->widget[SSW_WIDGET_ICONS].left + 2, top + 1);
+					SetDParam(0, c->index);
+					DrawSharingOption(STR_SHARING_SETTING_COMPANY, top, HasBit(this->current->allowed_companies, c->index), HasBit(this->future->allowed_companies, c->index));
+				}
+			}
+
+			if (ShouldDrawLine(current_line)) {
+				/* No companies at all, apart from ourselves? */
+				if (current_line == 2) {
+					/* The SSW_WIDGET_SETTINGS widget on its own is too narrow to fit the string */
+					DrawString(min(this->widget[SSW_WIDGET_ICONS].left, this->widget[SSW_WIDGET_SETTINGS].left),
+						max(this->widget[SSW_WIDGET_ICONS].right, this->widget[SSW_WIDGET_SETTINGS].right),
+						top, STR_SHARING_SETTING_NO_COMPANIES, TC_BLACK);
+					return; //don't draw the sharing delay
+				}
+				/* Blank line */
+				top += this->line_height;
+			}
+		} else {
+			/* draw text and buttons for all vehicle types */
+			for (VehicleType type = VEH_TRAIN; type < SHARING_VEHTYPES; type++) {
+				SubSprite sub = {0, (this->vscroll.pos - current_line) * this->line_height, INT32_MAX, (this->vscroll.pos + this->vscroll.cap - current_line) * this->line_height - 1};
+				DrawSprite(SPR_IMG_TRAINLIST + type, PAL_NONE, this->widget[SSW_WIDGET_ICONS].left, top, &sub);
+
+				/* Some special lines for trains */
+				if (type == VEH_TRAIN) {
+					if (ShouldDrawLine(current_line)) {
+						this->DrawSharingOption(STR_SHARING_SETTING_TRACK, top,
+							(this->current->GetSharingOption(VEH_TRAIN) & SHARING_TRACK) != 0,
+							(this->future->GetSharingOption(VEH_TRAIN) & SHARING_TRACK) != 0);
+					}
+					if (ShouldDrawLine(current_line)) {
+						this->DrawSharingOption(STR_SHARING_SETTING_DEPOT, top,
+							(this->current->GetSharingOption(VEH_TRAIN) & SHARING_DEPOT) != 0,
+							(this->future->GetSharingOption(VEH_TRAIN) & SHARING_DEPOT) != 0);
+					}
+				}
+
+				if (ShouldDrawLine(current_line)) {
+					this->DrawSharingOption(_sharing_station_string[type], top,
+						(this->current->GetSharingOption(type) & SHARING_STATION) != 0,
+						(this->future->GetSharingOption(type) & SHARING_STATION) != 0);
+				}
+
+				/* sharing fee */
+				if (ShouldDrawLine(current_line)) {
+					/* Draw arrow buttons in the correct state */
+					bool l_clickable = this->owner == _local_company && this->future->GetSharingFee(type) > 0;
+					bool r_clickable = this->owner == _local_company && this->future->GetSharingFee(type) < MAX_SHARING_FEE;
+					byte arrow_clicked = (type == this->clicked_row) ? this->clicked_side : 0;
+					if ((arrow_clicked == 1 && !l_clickable) || (arrow_clicked == 2 && !r_clickable)) {
+						this->OnTimeout();
+						arrow_clicked = 0;
+					}
+					DrawArrowButtons(this->widget[SSW_WIDGET_BUTTONS].left, top, COLOUR_YELLOW, arrow_clicked, l_clickable, r_clickable);
+
+					/* Draw the fee strings */
+					DrawString(this->widget[SSW_WIDGET_SETTINGS].left, this->widget[SSW_WIDGET_SETTINGS].right, top, type == VEH_TRAIN ? STR_SHARING_SETTING_MONTHLY_TOLL : STR_SHARING_SETTING_FEE, TC_BLACK);
+					SetDParam(0, this->current->GetSharingFee(type));
+					DrawString(this->widget[SSW_WIDGET_CURRENT].left,  this->widget[SSW_WIDGET_CURRENT].right,  top, STR_CONFIG_SETTING_CURRENCY, TC_ORANGE);
+					SetDParam(0, this->future->GetSharingFee(type));
+					DrawString(this->widget[SSW_WIDGET_FUTURE].left,   this->widget[SSW_WIDGET_FUTURE].right,   top, STR_CONFIG_SETTING_CURRENCY, TC_ORANGE);
+					top += this->line_height;
+				}
+				/* Add some spacing */
+				if (ShouldDrawLine(current_line)) top += this->line_height;
+			}
+		}
+
+		/* draw sharing delay */
+		if (ShouldDrawLine(current_line) && this->company->sharing_delay > 0) {
+			DrawString(this->widget[SSW_WIDGET_SETTINGS].left, this->widget[SSW_WIDGET_SETTINGS].right, top, STR_SHARING_CHANGES_TAKE_EFFECT, TC_WHITE);
+			SetDParam(0, this->company->sharing_delay);
+			DrawString(this->widget[SSW_WIDGET_CURRENT].left, this->widget[SSW_WIDGET_CURRENT].right, top, STR_SHARING_TAKE_EFFECT_MONTHS, TC_ORANGE);
+		}
+	}
+
+	virtual void OnResize(Point delta)
+	{
+		this->vscroll.cap = (this->widget[SSW_WIDGET_PANEL].bottom - this->widget[SSW_WIDGET_PANEL].top - 1) / this->line_height;
+		/* Make sure the size is exactly correct */
+		assert(this->widget[SSW_WIDGET_PANEL].top + this->vscroll.cap * this->line_height + 1 == this->widget[SSW_WIDGET_PANEL].bottom);
+
+		if (delta.x == 0) return;
+
+		bool ltr = this->widget[SSW_WIDGET_OPTIONS].left < this->widget[SSW_WIDGET_COMPANIES].left;
+		int center = (this->widget[SSW_WIDGET_PANEL].right - this->widget[SSW_WIDGET_PANEL].left + 1) >> 1;
+		/* Resize both buttons evenly */
+		this->widget[ltr ? SSW_WIDGET_OPTIONS : SSW_WIDGET_COMPANIES].right = center - 1;
+		this->widget[ltr ? SSW_WIDGET_COMPANIES : SSW_WIDGET_OPTIONS].left = center;
+	}
+
+	/** Handle a click on a boolean option.
+	 * @param type The vehicle type that was clicked on.
+	 * @param option Bitmask of sharing options (station/depot/tracks) to be changed.
+	 */
+	void HandleOptionClick(VehicleType type, uint8 option)
+	{
+		byte value = this->future->GetSharingOption(type) ^ option;
+		/* for trains, we don't want tracks to be disabled while stations or depots are enabled */
+		if (type == VEH_TRAIN && value != 0 && (value & SHARING_TRACK) == 0) {
+			if (option == SHARING_TRACK) {
+				/* tracks were just disabled, so clear all other bits as well */
+				value = 0;
+			} else {
+				/* stations or depots were just enabled, so enable tracks as well */
+				value |= SHARING_TRACK;
+			}
+		}
+		DoCommandP(0, SHARING_SETTING_RAIL + type, value, CMD_CHANGE_SHARING_SETTING | CMD_MSG(STR_CANT_CHANGE_SHARING_SETTING));
+	}
+
+	/** Handle a click on one of the fees.
+	 * @param type The vehicle type for which the fee is to be adjusted.
+	 * @param x The x-coordinate of the click, relative to the left edge of the button.
+	 * This is used to determine whether the left or right button was clicked.
+	 */
+	void HandleFeeClick(VehicleType type, int x)
+	{
+		if ((this->flags4 & WF_TIMEOUT_MASK) > WF_TIMEOUT_TRIGGER) {
+			_left_button_clicked = false;
+			return;
+		}
+		int half_button_width = (this->widget[SSW_WIDGET_BUTTONS].right - this->widget[SSW_WIDGET_BUTTONS].left + 1) / 2;
+
+		uint16 value = this->future->GetSharingFee(type);
+		uint16 new_value = value;
+		if (x < half_button_width && value > 0) {
+			/* left button */
+			this->clicked_row = type;
+			this->clicked_side = 1;
+			new_value = value - min(10, value);
+		} else if (x >= half_button_width && value < MAX_SHARING_FEE) {
+			/* right button */
+			this->clicked_row = type;
+			this->clicked_side = 2;
+			new_value = value + min(10, MAX_SHARING_FEE - value);
+		}
+		if (new_value != value) {
+			DoCommandP(0, SHARING_FEE_RAIL + type, new_value, CMD_CHANGE_SHARING_SETTING | CMD_MSG(STR_CANT_CHANGE_SHARING_SETTING));
+			this->flags4 |= WF_TIMEOUT_BEGIN;
+			_left_button_clicked = false;
+		}
+	}
+
+	/** Handle a click on one of the companies in the companies tab.
+	 * @param index Index in the list of the clicked company. NOT the same as CompanyID.
+	 */
+	void HandleCompanyClick(byte index)
+	{
+		Company *c;
+		FOR_ALL_COMPANIES(c) {
+			if (c->index == this->owner) continue;
+			if (index-- == 0) {
+				DoCommandP(0, SHARING_ALLOWED_COMPANIES, this->future->allowed_companies ^ (1 << c->index), CMD_CHANGE_SHARING_SETTING | CMD_MSG(STR_CANT_CHANGE_SHARING_SETTING));
+			}
+		}
+	}
+
+	virtual void OnClick(Point pt, int widget)
+	{
+		int y, line;
+		switch (widget) {
+			case SSW_WIDGET_OPTIONS:
+				/* Switch to options tab */
+				this->companies_tab = false;
+				this->SetDirty();
+				return;
+			case SSW_WIDGET_COMPANIES:
+				/* Switch to companies tab */
+				this->companies_tab = true;
+				this->SetDirty();
+				return;
+			case SSW_WIDGET_PANEL:
+				if (this->owner != _local_company) return;
+
+				y = pt.y - this->widget[SSW_WIDGET_BUTTONS].top;
+				/* Ignore clicks on the top or bottom pixel, to avoid changing invisible settings */
+				if (y == this->widget[SSW_WIDGET_BUTTONS].top || y == this->widget[SSW_WIDGET_BUTTONS].bottom) return;
+				line = (y / this->line_height) - 1 + this->vscroll.pos;
+
+				if (pt.x >= this->widget[SSW_WIDGET_BUTTONS].left && pt.x <= this->widget[SSW_WIDGET_BUTTONS].right) {
+					/* A button is clicked, process the click further below */
+					break;
+				} else if (pt.x >= this->widget[SSW_WIDGET_FUTURE].left && pt.x <= this->widget[SSW_WIDGET_FUTURE].right) {
+					/* Possibly clicked a fee, if that is the case, show a query string window.
+					 * Line numbers correspond to the line numbers in the switch statement below */
+					switch (line) {
+						case 3:  this->current_query_type = VEH_TRAIN;    break;
+						case 6:  this->current_query_type = VEH_ROAD;     break;
+						case 9:  this->current_query_type = VEH_SHIP;     break;
+						case 12: this->current_query_type = VEH_AIRCRAFT; break;
+						default: return;
+					}
+					SetDParam(0, this->future->GetSharingFee(this->current_query_type) * _currency->rate);
+					ShowQueryString(STR_CONFIG_SETTING_INT32, STR_CONFIG_SETTING_QUERY_CAPT, 8, 100, this, CS_NUMERAL, QSF_NONE);
+				}
+				return;
+			default: return;
+		}
+
+		if (this->companies_tab) {
+			this->HandleCompanyClick(line);
+			return;
+		}
+
+		int x = pt.x - this->widget[SSW_WIDGET_BUTTONS].left;
+		switch (line) {
+			/* This is basically a table to map line numbers to certain actions */
+			case 0: this->HandleOptionClick(VEH_TRAIN, SHARING_TRACK); return;
+			case 1: this->HandleOptionClick(VEH_TRAIN, SHARING_DEPOT); return;
+			case 2: this->HandleOptionClick(VEH_TRAIN, SHARING_STATION); return;
+			case 3: this->HandleFeeClick(VEH_TRAIN, x); return;
+			/* blank line */
+			case 5: this->HandleOptionClick(VEH_ROAD, SHARING_STATION | SHARING_DEPOT); return;
+			case 6: this->HandleFeeClick(VEH_ROAD, x); return;
+			/* blank line */
+			case 8: this->HandleOptionClick(VEH_SHIP, SHARING_STATION | SHARING_DEPOT); return;
+			case 9: this->HandleFeeClick(VEH_SHIP, x); return;
+			/* blank line */
+			case 11: this->HandleOptionClick(VEH_AIRCRAFT, SHARING_STATION | SHARING_DEPOT); return;
+			case 12: this->HandleFeeClick(VEH_AIRCRAFT, x); return;
+		}
+	}
+
+	virtual void OnQueryTextFinished(char *str)
+	{
+		if (StrEmpty(str)) return;
+		int32 value = atoi(str);
+		value /= _currency->rate;
+		value = Clamp(value, 0, MAX_SHARING_FEE);
+		DoCommandP(0, SHARING_FEE_RAIL + this->current_query_type, value, CMD_CHANGE_SHARING_SETTING | CMD_MSG(STR_CANT_CHANGE_SHARING_SETTING));
+	}
+
+	virtual void OnTimeout()
+	{
+		this->clicked_row = 0;
+		this->clicked_side = 0;
+		this->SetDirty();
+	}
+};
+
+/** widget definition for infrastructure sharing window */
+static const Widget _sharing_settings_widgets[] = {
+	{   WWT_CLOSEBOX,   RESIZE_NONE,  COLOUR_GREY,     0,    10,     0,    13, STR_BLACK_CROSS,       STR_TOOLTIP_CLOSE_WINDOW},            // SSW_WIDGET_CLOSEBOX
+	{    WWT_CAPTION,  RESIZE_RIGHT,  COLOUR_GREY,    11,   371,     0,    13, STR_SHARING_CAPTION,   STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS},  // SSW_WIDGET_CAPTION
+	{  WWT_STICKYBOX,     RESIZE_LR,  COLOUR_GREY,   372,   383,     0,    13, 0x0,                   STR_STICKY_BUTTON},                   // SSW_WIDGET_STICKY
+	{      WWT_PANEL,     RESIZE_RB,  COLOUR_GREY,     0,   371,    14,   103, 0x0,                   STR_SHARING_PANEL_TOOLTIP},           // SSW_WIDGET_PANEL
+	{      WWT_EMPTY, RESIZE_BOTTOM,  COLOUR_GREY,     2,    21,    14,   103, 0x0,                   STR_NULL},                            // SSW_WIDGET_ICONS
+	{      WWT_EMPTY,     RESIZE_RB,  COLOUR_GREY,    24,   183,    14,   103, 0x0,                   STR_NULL},                            // SSW_WIDGET_SETTINGS
+	{      WWT_EMPTY,    RESIZE_LRB,  COLOUR_GREY,   186,   265,    14,   103, 0x0,                   STR_NULL},                            // SSW_WIDGET_CURRENT
+	{      WWT_EMPTY,    RESIZE_LRB,  COLOUR_GREY,   268,   287,    14,   103, 0x0,                   STR_NULL},                            // SSW_WIDGET_BUTTONS
+	{      WWT_EMPTY,    RESIZE_LRB,  COLOUR_GREY,   290,   369,    14,   103, 0x0,                   STR_NULL},                            // SSW_WIDGET_FUTURE
+	{  WWT_SCROLLBAR,    RESIZE_LRB,  COLOUR_GREY,   372,   383,    14,   103, 0x0,                   STR_TOOLTIP_VSCROLL_BAR_SCROLLS_LIST},// SSW_WIDGET_SCROLL
+	{ WWT_PUSHTXTBTN,    RESIZE_RTB,  COLOUR_GREY,     0,   185,    104,  115, STR_SHARING_OPTIONS,   STR_SHARING_OPTIONS_TOOLTIP},         // SSW_WIDGET_OPTIONS
+	{ WWT_PUSHTXTBTN,   RESIZE_LRTB,  COLOUR_GREY,   186,   371,    104,  115, STR_SHARING_COMPANIES, STR_SHARING_COMPANIES_TOOLTIP},       // SSW_WIDGET_COMPANIES
+	{  WWT_RESIZEBOX,   RESIZE_LRTB,  COLOUR_GREY,   372,   383,    104,  115, 0x0,                   STR_RESIZE_BUTTON},                   // SSW_WIDGET_RESIZE
+	{   WIDGETS_END},
+};
+
+static const NWidgetPart _nested_sharing_settings_widgets[] = {
+	NWidget(NWID_HORIZONTAL), // Window header
+		NWidget(WWT_CLOSEBOX, COLOUR_GREY, SSW_WIDGET_CLOSEBOX),
+		NWidget(WWT_CAPTION, COLOUR_GREY, SSW_WIDGET_CAPTION), SetDataTip(STR_SHARING_CAPTION, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
+		NWidget(WWT_STICKYBOX, COLOUR_GREY, SSW_WIDGET_STICKY),
+	EndContainer(),
+	NWidget(NWID_HORIZONTAL),
+		NWidget(WWT_PANEL, COLOUR_GREY, SSW_WIDGET_PANEL), SetDataTip(0x0, STR_SHARING_PANEL_TOOLTIP), SetFill(1, 1),
+			NWidget(NWID_HORIZONTAL), SetPIP(2, 2, 2),
+				/* Empty widgets to position the text columns */
+				NWidget(WWT_EMPTY, COLOUR_GREY, SSW_WIDGET_ICONS),    SetMinimalSize(20,  90), SetResize(0, 1),
+				NWidget(WWT_EMPTY, COLOUR_GREY, SSW_WIDGET_SETTINGS), SetMinimalSize(160, 90), SetResize(1, 1),
+				NWidget(WWT_EMPTY, COLOUR_GREY, SSW_WIDGET_CURRENT),  SetMinimalSize(80,  90), SetResize(1, 1),
+				NWidget(WWT_EMPTY, COLOUR_GREY, SSW_WIDGET_BUTTONS),  SetMinimalSize(20,  90), SetResize(0, 1),
+				NWidget(WWT_EMPTY, COLOUR_GREY, SSW_WIDGET_FUTURE),   SetMinimalSize(80,  90), SetResize(1, 1),
+			EndContainer(),
+		EndContainer(),
+		NWidget(WWT_SCROLLBAR, COLOUR_GREY, SSW_WIDGET_SCROLL),
+	EndContainer(),
+	NWidget(NWID_HORIZONTAL),
+		NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, SSW_WIDGET_OPTIONS),   SetMinimalSize(0, 12), SetResize(1, 0), SetDataTip(STR_SHARING_OPTIONS, STR_SHARING_OPTIONS_TOOLTIP), SetFill(1, 0),
+		NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, SSW_WIDGET_COMPANIES), SetMinimalSize(0, 12), SetResize(1, 0), SetDataTip(STR_SHARING_COMPANIES, STR_SHARING_COMPANIES_TOOLTIP), SetFill(1, 0),
+		NWidget(WWT_RESIZEBOX,  COLOUR_GREY, SSW_WIDGET_RESIZE),
+	EndContainer(),
+};
+
+static const WindowDesc _sharing_settings_desc(
+	WDP_AUTO, WDP_AUTO, 384, 116, 384, 215,
+	WC_SHARING_OPTIONS, WC_COMPANY,
+	WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET | WDF_UNCLICK_BUTTONS | WDF_STICKY_BUTTON | WDF_RESIZABLE,
+	_sharing_settings_widgets, _nested_sharing_settings_widgets, lengthof(_nested_sharing_settings_widgets)
+);
+
+static void ShowSharingSettingsWindow(CompanyID company)
+{
+	if (_settings_game.sharing.enable_sharing && _settings_game.sharing.individual_allowed && IsValidCompanyID(company)) {
+		AllocateWindowDescFront<SharingSettingsWindow>(&_sharing_settings_desc, company);
+	}
+}
diff -r ee55d0546576 src/depot_gui.cpp
--- a/src/depot_gui.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/depot_gui.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -21,6 +21,7 @@
 #include "tilehighlight_func.h"
 #include "window_gui.h"
 #include "vehiclelist.h"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -311,7 +312,7 @@
 		uint16 boxes_in_each_row = this->widget[DEPOT_WIDGET_MATRIX].data & 0xFF;
 
 		/* setup disabled buttons */
-		this->SetWidgetsDisabledState(!IsTileOwner(tile, _local_company),
+		this->SetWidgetsDisabledState(!AreDepotOperationsAllowed(this->window_number, _local_company, this->type),
 			DEPOT_WIDGET_STOP_ALL,
 			DEPOT_WIDGET_START_ALL,
 			DEPOT_WIDGET_SELL,
diff -r ee55d0546576 src/economy.cpp
--- a/src/economy.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/economy.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -32,6 +32,7 @@
 #include "autoreplace_func.h"
 #include "company_gui.h"
 #include "signs_base.h"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -367,6 +368,32 @@
 		}
 	}
 
+	/* make the sharing settings the most permissive of the two companies */
+	if (new_owner != INVALID_OWNER) {
+		CompanySharingSettingsEntry *old_settings = &GetCompany(old_owner)->sharing_current;
+		CompanySharingSettingsEntry *new_settings = &GetCompany(new_owner)->sharing_current;
+		for (VehicleType vt = VEH_TRAIN; vt < SHARING_VEHTYPES; vt++) {
+			new_settings->SetSharingOption(vt, old_settings->GetSharingOption(vt) | new_settings->GetSharingOption(vt));
+			new_settings->SetSharingFee(vt, min(old_settings->GetSharingFee(vt), new_settings->GetSharingFee(vt)));
+		}
+		new_settings->allowed_companies |= old_settings->allowed_companies;
+	} else {
+		/* Disable sharing for the old company
+		 * This will cause all vehicles on the old company's infrastructure
+		 * to be removed when HandleSharingChange is called */
+		for (VehicleType vt = VEH_TRAIN; vt < SHARING_VEHTYPES; vt++) {
+			GetCompany(old_owner)->sharing_current.SetSharingOption(vt, 0);
+		}
+		HandleSharingChange();
+	}
+
+	/* disallow the old company from all infrastructure */
+	Company *c;
+	FOR_ALL_COMPANIES(c) {
+		ClrBit(c->sharing_future.allowed_companies, old_owner);
+		ClrBit(c->sharing_current.allowed_companies, old_owner);
+	}
+
 	/*  Change ownership of tiles */
 	{
 		TileIndex tile = 0;
@@ -660,6 +687,23 @@
 
 		SubtractMoneyFromCompany(CommandCost(EXPENSES_OTHER, _price.station_value >> 2));
 	}
+}
+
+static void CompaniesUpdateSharing()
+{
+	Company *c;
+	byte changed_vehtypes = 0;
+	FOR_ALL_COMPANIES(c) {
+		if (c->sharing_delay > 0 && --c->sharing_delay == 0 && !c->sharing_current.Equals(&c->sharing_future)) {
+			changed_vehtypes |= c->sharing_current.Copy(&c->sharing_future);
+			if (c->index != _local_company) {
+				SetDParam(0, c->index);
+				AddNewsItem(STR_SHARING_CHANGE_HAPPENED, NS_COMPANY_SHARING, 0, 0);
+			}
+		}
+	}
+	HandleSharingChange(changed_vehtypes);
+	InvalidateWindowClasses(WC_SHARING_OPTIONS);
 }
 
 static void HandleEconomyFluctuations()
@@ -1823,6 +1867,7 @@
 	CompaniesGenStatistics();
 	if (_settings_game.economy.inflation) AddInflation();
 	CompaniesPayInterest();
+	CompaniesUpdateSharing();
 	/* Reset the _current_company flag */
 	_current_company = OWNER_NONE;
 	HandleEconomyFluctuations();
diff -r ee55d0546576 src/economy_type.h
--- a/src/economy_type.h	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/economy_type.h	Sat Apr 25 19:58:24 2009 +0200
@@ -126,6 +126,8 @@
 	EXPENSES_SHIP_INC,
 	EXPENSES_LOAN_INT,
 	EXPENSES_OTHER,
+	EXPENSES_SHARED_RUN,
+	EXPENSES_SHARED_INC,
 	EXPENSES_END,
 	INVALID_EXPENSES      = 0xFF,
 };
